unit Dll1Code;

interface

uses Windows, Dialogs, SysUtils, Forms;

type
  TTestObject = class(TObject)
  public
    ObjectName: String;
    constructor Create;
  end;

procedure DllShowMessage(Msg: String);

threadvar
  tlObject: TTestObject;

const
  MessageBoxTitle = 'Dll3';
  CRLF = #13 + #10;

implementation

procedure DllShowMessage(Msg: String);
begin
  MessageBox(GetDesktopWindow, PChar(Msg), MessageBoxTitle,
             MB_OK or MB_SETFOREGROUND or MB_TASKMODAL);
end;

{ TTestObject }
constructor TTestObject.Create;
begin
  ObjectName := 'Test Object: ' + IntToStr(GetCurrentThreadID);
end;

procedure DllEntry(Reason: Integer);
begin
  case Reason of
    DLL_THREAD_ATTACH: begin
      tlObject := TTestObject.Create;
      DllShowMessage(tlObject.ObjectName);
    end;
    DLL_THREAD_DETACH: begin
      if (tlObject = nil) then
        DllShowMessage('Object is nil.')
      else
        DllShowMessage(tlObject.ObjectName);
      tlObject.Free;
    end;
  end;
end;

initialization

  IsMultiThread := True;
  DllProc := @DllEntry;
  tlObject := TTestObject.Create;

finalization

  if (tlObject = nil) then
    DllShowMessage('Object is nil.')
  else
    DllShowMessage(tlObject.ObjectName);
  tlObject.Free;

end.
